#include "HipRecord.h"
#include <iostream>
#include <cstdlib>
#include <cmath>

bool
HipRecord::ParseRecord(const std::string& line) {
  fLine = line;
  fCatalog = line.substr(0, 0);
  fHIP = (int)atoi(&line[8]);
  fProxy = line.substr(15, -15);
  fRAhms = line.substr(17, 11);
  fDEdms = line.substr(29, 11);
  fVmag = (float)atof(&line[41]);
  fVarFlag = (char)atoi(&line[47]);
  fr_Vmag = line.substr(49, -49);
  fRAdeg = (double)atof(&line[51]);
  fDEdeg = (double)atof(&line[64]);
  fAstroRef = line.substr(77, -77);
  fPlx = (float)atof(&line[79]);
  fpmRA = (double)atof(&line[87]);
  fpmDE = (double)atof(&line[96]);
  fe_RAdeg = (float)atof(&line[105]);
  fe_DEdeg = (float)atof(&line[112]);
  fe_Plx = (float)atof(&line[119]);
  fe_pmRA = (float)atof(&line[126]);
  fe_pmDE = (float)atof(&line[133]);
  fDE_RA = (float)atof(&line[140]);
  fPlx_RA = (float)atof(&line[146]);
  fPlx_DE = (float)atof(&line[152]);
  fpmRA_RA = (float)atof(&line[158]);
  fpmRA_DE = (float)atof(&line[164]);
  fpmRA_Plx = (float)atof(&line[170]);
  fpmDE_RA = (float)atof(&line[176]);
  fpmDE_DE = (float)atof(&line[182]);
  fpmDE_Plx = (float)atof(&line[188]);
  fpmDE_pmRA = (float)atof(&line[194]);
  fF1 = (short int)atoi(&line[200]);
  fF2 = (float)atof(&line[204]);
  fBTmag = (float)atof(&line[217]);
  fe_BTmag = (float)atof(&line[224]);
  fVTmag = (float)atof(&line[230]);
  fe_VTmag = (float)atof(&line[237]);
  fm_BTmag = line.substr(243, -243);
  fB_V = (float)atof(&line[245]);
  fe_B_V = (float)atof(&line[252]);
  fr_B_V = line.substr(258, -258);
  fV_I = (float)atof(&line[260]);
  fe_V_I = (float)atof(&line[265]);
  fr_V_I = line.substr(270, -270);
  fCombMag = line.substr(272, -272);
  fHpmag = (float)atof(&line[274]);
  fe_Hpmag = (float)atof(&line[282]);
  fHpscat = (float)atof(&line[289]);
  fo_Hpmag = (short int)atoi(&line[295]);
  fm_Hpmag = line.substr(299, -299);
  fHpmax = (float)atof(&line[301]);
  fHPmin = (float)atof(&line[307]);
  fPeriod = (float)atof(&line[313]);
  fHvarType = line.substr(321, -321);
  fmoreVar = line.substr(323, -323);
  fmorePhoto = line.substr(325, -325);
  fCCDM = line.substr(327, 10);
  fn_CCDM = line.substr(338, -338);
  fNsys = (char)atoi(&line[340]);
  fNcomp = (char)atoi(&line[343]);
  fMultFlag = line.substr(346, -346);
  fSource = line.substr(348, -348);
  fQual = line.substr(350, -350);
  fm_HIP = line.substr(352, 2);
  ftheta = (short int)atoi(&line[355]);
  frho = (float)atof(&line[359]);
  fe_rho = (float)atof(&line[367]);
  fdHp = (float)atof(&line[373]);
  fe_dHp = (float)atof(&line[379]);
  fSurvey = line.substr(384, -384);
  fChart = line.substr(386, -386);
  fNotes = line.substr(388, -388);
  fHD = (int)atoi(&line[390]);
  fBD = line.substr(397, 10);
  fCoD = line.substr(408, 10);
  fCPD = line.substr(419, 10);
  f_V_I_red = (float)atof(&line[430]);
  fSpType = line.substr(435, 12);
  fr_SpType = line.substr(448, -448);
  return true;
}

